#ifndef __SOUNDRECORDER_H__
#define __SOUNDRECORDER_H__


#include <windows.h>
#include <mmsystem.h>
#include <mmreg.h>
#include "lame.h"

#define NBUFFERS 3
#define MP3_BUFF_SIZE 143360

typedef enum 
{
	RS_STOPPED,
	RS_RECORDING,
	RS_PAUSED
} RecorderState;

typedef struct
{
	HANDLE hTmpFile;
	WAVEFORMATEX wf;
	HWAVEIN hwi;
	WAVEHDR ** hdr;
	lame_global_flags * gfp;
	unsigned char mp3_buffer[MP3_BUFF_SIZE];
	int nRecBytes;
	int usedBuffers;
	RecorderState state;
	TCHAR outFile[MAX_PATH];
} SoundRecorderTag, *HRECORDER;

#ifdef __CPLUSPLUS
extern "C" {
#endif

HRECORDER SoundRecorderInit();
void SoundRecorderClose(HRECORDER hRec);

void SoundRecorderStart(HRECORDER hRec);
void SoundRecorderPause(HRECORDER hRec);
void SoundRecorderResume(HRECORDER hRec);
void SoundRecorderStop(HRECORDER hRec);

void SoundRecorderSetOutputFile(HRECORDER hRec, const char * file);
RecorderState SoundRecorderGetState(HRECORDER hRec);
int SoundRecoderGetSecondsRecorded(HRECORDER hRec);

#ifdef __CPLUSPLUS
}
#endif

static void CALLBACK CallbackFuncRec(HWAVEIN hwi,
			UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2);

#endif //__SOUNDRECORDER_H__