// DSObjectChooseDialog.cpp : implementation file
//

#include "stdafx.h"
#include "WinTracker.h"
#include "DSObjectChooseDialog.h"

#include <string.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//fction appele par DirectSoundEnumerate pour chaque objet trouv
BOOL CALLBACK DSEnumCallback(
  LPGUID lpGuid,            
  LPCSTR lpcstrDescription,  
  LPCSTR lpcstrModule,       
  LPVOID lpContext)
{
    char * tmp = NULL;
    LPGUID tg = NULL;

    //on rcupre le dialogue dans le paramtre
    CDSObjectChooseDialog *dialog = (CDSObjectChooseDialog *)lpContext;
    tmp = new char[strlen(lpcstrDescription)+1];
    strcpy(tmp, lpcstrDescription);
    //on ajoute le GUID  la liste des GUIDs
    //et la description  la liste des descriptions
    if (lpGuid != NULL)
    {
        tg = new GUID;
        memcpy(tg, lpGuid, sizeof(GUID));
    }
    dialog->m_GUIDList.AddHead((LPVOID)tg);
    dialog->m_ObjectList.AddString(tmp);
    
    return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CDSObjectChooseDialog dialog


CDSObjectChooseDialog::CDSObjectChooseDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CDSObjectChooseDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDSObjectChooseDialog)
	m_CurrentObject = _T("");
	//}}AFX_DATA_INIT
}


void CDSObjectChooseDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDSObjectChooseDialog)
	DDX_Control(pDX, IDOK, m_okbtn);
	DDX_Control(pDX, IDC_LIST1, m_ObjectList);
	DDX_Text(pDX, IDC_EDIT1, m_CurrentObject);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDSObjectChooseDialog, CDialog)
	//{{AFX_MSG_MAP(CDSObjectChooseDialog)
	ON_WM_SHOWWINDOW()
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelchangeList1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDSObjectChooseDialog message handlers

void CDSObjectChooseDialog::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	    
	// TODO: Add your message handler code here
	if (!bShow) return;//si on cache, on fait rien
    
    // listons tous les objets DirectSound
    DirectSoundEnumerate((LPDSENUMCALLBACK)&DSEnumCallback, this);

    UpdateData(FALSE);

}

void CDSObjectChooseDialog::OnSelchangeList1() 
{
	// TODO: Add your control notification handler code here
	// on update dans l'edit a chaque fois qu'on selectionne une description
    
    int sel = m_ObjectList.GetCurSel();
    if (sel != LB_ERR)
    {
        m_ObjectList.GetText(sel, m_CurrentObject);
        the_GUID = (LPGUID)m_GUIDList.GetAt(m_GUIDList.FindIndex(sel));
        m_okbtn.EnableWindow(TRUE);
    }
    UpdateData(FALSE);
}

LPGUID CDSObjectChooseDialog::GetDSObject()
{
    return the_GUID;
}
