// WinTrackerDlg.h : header file
//

#if !defined(AFX_WINTRACKERDLG_H__37F35392_0FA3_4AFD_9957_5237002BD557__INCLUDED_)
#define AFX_WINTRACKERDLG_H__37F35392_0FA3_4AFD_9957_5237002BD557__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <mmsystem.h>       // multimedia functions
#include <mmreg.h>          // multimedia registered formats
#include <dsound.h>         // DirectSound

/////////////////////////////////////////////////////////////////////////////
// CWinTrackerDlg dialog
//
// Dialogue principal
//

class CWinTrackerDlg : public CDialog
{
// Construction
public:
	void ApplyControl();                    //appliquer les controlesdu volume a directsound
	int percent(int num, int perc);         //calcul de pourcentage
	void PlayNote(int ecart);               //jouer une note avec un ecart
	CWinTrackerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CWinTrackerDlg)
	enum { IDD = IDD_WINTRACKER_DIALOG };
	CSliderCtrl	m_VolumeSlider;
	CSliderCtrl	m_PitchSlider;
	CSliderCtrl	m_BalanceSlider;
	BOOL	m_StopNote;
	BOOL	m_BoucleNote;
	CString	m_BalEdit;
	CString	m_PitchEdit;
	CString	m_VolEdit;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWinTrackerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	LPDIRECTSOUNDBUFFER soundBuffer;        //buffer de son directsound
    LPDIRECTSOUND lpDS;                     //objet directsound
	
    int vol;            //volume
    int pan;            //balance
    int freq;           //ecart de pitch
    int filefreq;       //frequence specifique au fichier ouvert (22050, 44100)
    int notefreq;       //frequence associe a la note en cours
    
    BOOL isDSok;        //directsound initialis ?
	BOOL isWaveOpen;    //y'a t'il un fichier ouvert ?
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CWinTrackerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnAbout();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnUpdateFichierProprits(CCmdUI* pCmdUI);
	afx_msg void OnOpen();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnUpdateOpen(CCmdUI* pCmdUI);
	afx_msg void OnFichierProprits();
	afx_msg void OnButtonDo1();
	afx_msg void OnButtonDod1();
	afx_msg void OnButtonRe1();
	afx_msg void OnButtonRed1();
	afx_msg void OnButtonMi1();
	afx_msg void OnButtonFa1();
	afx_msg void OnButtonFad1();
	afx_msg void OnButtonSol1();
	afx_msg void OnButtonSold1();
	afx_msg void OnButtonLa1();
	afx_msg void OnButtonLad1();
	afx_msg void OnButtonSi1();
	afx_msg void OnButtonDo2();
	afx_msg void OnButtonDod2();
	afx_msg void OnButtonRe2();
	afx_msg void OnButtonRed2();
	afx_msg void OnButtonMi2();
	afx_msg void OnButtonFa2();
	afx_msg void OnButtonFad2();
	afx_msg void OnButtonSol2();
	afx_msg void OnButtonSold2();
	afx_msg void OnButtonLa2();
	afx_msg void OnButtonLad2();
	afx_msg void OnButtonSi2();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WINTRACKERDLG_H__37F35392_0FA3_4AFD_9957_5237002BD557__INCLUDED_)
